SmartGit 17.0.3 (2017-03-21)
============================
New Features, Improvements
--------------------------
- Git:
  - Cleanup: removed option "And reset ('expire') reflogs now" because stashes might be deleted
  - Refresh:
    - for "Modified (EOLs only)" it now is distinguished between stageable and non-stageable
    - rename detection performance improvements for large .gitattributes and many untracked files
- JIRA: VM property "smartgit.jira.closedStates" now supports states containing spaces in the name
- error dialogs: set VM property "smartgit.ui.errorDialog.markdownSupport" to "false" to disable
  markdown formatting

Fixed Bugs
----------
- Git:
  - Log:
    - hangs on certain Linux systems (resolution and scaling factor dependend)
    - Save As: internal error if entering path "C:foo.txt"
  - Rebase: failed in case of commits without commit message
  - Refresh:
    - added/removed/untracked/missing files might not be reported if refresh was interrupted (and
      resumed) by another operation
    - Refresh (Windows): possible error for read-locked files ("another process has locked a
      portion of the file")
- Hg:
  - Conflict Solver: did not show the proper information for renamed files
  - Refresh:
    - "Copied From" path wrong (pointing to file itself instead of copy source)
    - moved, conflicting file showed up as moved instead of conflicting
- Distributed Review add-on: possible performance problems for large review repositories (due to
  many refs)
- GUI: 
  - Clone: did not remember recently used URLs
  - Linux: tree/table tooltips hard to read
- Windows installer bundle: missed dictionaries directory


SmartGit 17.0.2 (2017-02-09)
============================
New Features, Improvements
--------------------------
- Git:
  - Refresh: untracked/missing rename detection honors "core.jgit.similarityFileSizeLimit"
    to avoid out-of-memory errors

Fixed Bugs
----------
- Git:
  - Log:
    - GitHub: possible endless refreshing
- GitHub: updated default fingerprint
- GitHub, other hosting providers: do not warn for changed fingerprint if it's a
  known, new fingerprint 
- undone "automatically set java.net.useSystemProxies=true (if not set) to
  improve auto-detection of proxies" because it causes to always use the system
  proxy, even if "no proxy" was configured in SmartGit
- GUI (Windows): sort column was too dark in default bright theme


SmartGit 17.0.1 (2017-01-27)
============================
New Features, Improvements
--------------------------
- automatically set java.net.useSystemProxies=true (if not set) to improve
  auto-detection of proxies

Fixed Bugs
----------
- Git:
  - Commit, Stage, others: fails on renamed files in submodules with 'pathspec
    ... did not match any files' error
  - Log, Refresh: did not refresh if .git/-admin root was not located below
    working tree root (like for submodules)
- SVN:
  - possible "URL mismatch" error
- OS X:
  - possible UI hangs related to file monitoring
  - file table: clearing selection removed alternating row coloring
  - preferences, Edit Diff dialog: wrong radio button preselected
- http(s) authentication: proxy passwords containing special characters like #
  did not work
- default external tools were not recreated after removing tools.xml and
  restarting SmartGit


SmartGit 17.0.0 (2017-01-17)
============================
Fixed Bugs
----------
- different input fields: Ctrl+Alt+Z performed undone; preventing entering Alt Gr+Z
  characters on some keyboards


SmartGit 17 RC 3 (2017-01-12)
=============================
New Features, Improvements
--------------------------
- Git:
  - Refresh and Log: added system property "smartgit.renameDetection.similarityThreshold"
    determining how similar files must be to be detected as renamed (0..100)

Fixed Bugs
----------
- Git:
  - Index Editor: when closing while Save is in process, another Save-Discard
    dialog popped up
  - Refresh (OS X): phantom modifications may remain until next full refresh
- OS X:
  - maximized (== fullscreen) state was not preserved
  - spellchecker popup occurred 2 times
    (work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=496446)
  - OS X 10.12: opening a non-fullscreen window from a fullscreen window did
    not switch to a new desktop
    (work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=509741)
  - tree controls: incorrect painting of selection
    (work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=510172)


SmartGit 17 RC 2 (2017-01-03)
=============================
New Features, Improvements
--------------------------
- main toolbar: the Abort button is added automatically

Fixed Bugs
----------
- Git:
  - Refresh:
    - after renaming/removing added (or rename-detected) file, refresh did not
      update this file
    - false-positive modifications (which only vanished after invoking
      "git status")
    - possible dead-lock for background refresh
- Changes view:
  - "No more changes" popup was hard to read on Ubuntu
  - Current Line display: possible internal error while painting
- some proxies did not work because of the unproxied DNS query


SmartGit 17 RC 1 (2016-12-21)
=============================
Noteworthy Changes
------------------
- the version has been renamed to 17 (for the first expected release in 2017)

New Features, Improvements
--------------------------
- Git:
  - Journal:
    - for local-only Git-Flow features, only commits from feature branch are
      highlighted as "ahead" (orange)
    - for Git-Flow features latest develop commit is denoted if develop isn't
      the auxiliary branch
    - option to hide common commits
  - Log:
    - Cherry Pick: show (hidable) dialog if conflict occurred
    - when applying filter, the list is sorted by Commit Time, then Author Time
  - Pull: "remember as default" resets branch.rebase config options
  - Rebase: set system property "smartgit.rebase.disablePreserveMerge" to
    "true" to disable "--preserve-merges"
  - Refresh, rename detection:
    - notification in case of long running rename detection
    - performance improvement in case of no missing files
    - option to disable detection or disable for missing and untracked files
- Hg: support for version 4.0
- Conflict Solver: allow to skip warning dialog notifying about not having
  resolved all conflicts

Fixed Bugs
----------
- Git:
  - DeepGit integration: shows error if failed to start DeepGit
  - Delete Tag: failed if one remote repository was read-only (e.g. upstream)
  - Log:
    - Branches: "Show Content" on stash created entries in "Commit" sections
- Mark as Favorite: possible dead-lock


SmartGit 8.1 preview 5 (2016-12-07)
===================================
New Features, Improvements
--------------------------
- Git:
  - Abort command/toolbar button to abort Rebase or Merge
  - Add Tag, Create Remote: replaces invalid characters with valid ones
  - DeepGit integration honors selected line from Changes view
  - Log:
    - added preferences option to allow opening multiple log windows for the
      same repository
    - Show Changes:
      - works on multi-commit selection in Commits view
      - in case of 2 selected files, ask whether to compare against each other
        or separately
    - separate text color for messages of merge commits (that usually are not
      that important)
  - Push to Gerrit: honor tracked branch
  - Refresh: shows renamed files; not just added-removed, but also new-missing
    ones
- GUI: theming support; the default dark-theme can be selected in the
  preferences

Fixed Bugs
----------
- Git:
  - Branches, Push To: always preselected Custom Ref if it was used one time in
    the past
  - Log:
    - for a renamed file, when selecting 2 commits, the wrong file was selected
      in the Files view
    - Comments view: delayed "could not be revealed" error if Changes view was
      not visible
- Check for Update at startup: possible internal error
- Compare, Changes view, Current long lines:
  - often showed the wrong inner-line
  - did not repaint immediately when changing the editor theme
  changes
- SSH: incorrect usage of user name from ~/.ssh/config
- settings:
  - it could be possible that settings files were written with 00-byte content
  - incorrectly named settings file


SmartGit 8.1 preview 4 (2016-11-18)
===================================
New Features, Improvements
--------------------------
- Git:
  - BitBucket server: for inaccessible pull requests, internal
    /refs/pull-requests/-refs are used to still work with them
  - BitBucket/GitHub: when fetching pull requests, trees are tried to merge for
    the virtual pull request commit
  - Branches:
    - ability to copy ref name or tag message (as part of the ref name)
    - more detailed rendering for push.default != tracking branch
  - Checkout remote branch:
    - suggest <branch>-<remote> as name if there are multiple remotes and
      <branch> is already existing
    - "tracking" checkbox is not cleared when editing the branch name, but only
      if a local branch tracking this remote already exists
  - Cleanup: added VM property smartgit.cleanup.maxAllowedLooseObjects to
    configure the limit when SmartGit shows a needs-cleanup-notification
  - Journal/Log, Author column: "." is used as separator, too
  - Log: Copy actions are now available if command is running
- Autoupdate: no "Started downloading version x.y" anymore
- Compare, Changes view: optionally show left and right current line one above
  the other
- Confirmation dialogs: some confirmation dialogs, e.g. to switch branches, can
  be skipped by clicking "Don't show again" checkbox
- Docking: when closing a view, a message is displayed how to show the view
  again
- Log: customizable branch coloring, also for dark themes
- Out-of-memory-instructions improved
- Preferences: ability to show stored passwords

Fixed Bugs
----------
- Git:
  - F2 while a file was selected did not open the rename file command
  - Log: - refresh after commands was broken
- BitBucket, GitHub: pull requests for branches with / in their name could not
  be fetched and used
- Repositories: dragging repositories to other groups was broken


SmartGit 8.1 preview 3 (2016-10-25)
===================================
Noteworthy Changes
------------------
- Java 1.8 is now required to launch SmartGit

New Features, Improvements
--------------------------
- Conflict Solver: ability to show Base file in separate left-base-right window
- DeepGit integration: an installed DeepGit is detected and an appropriate menu
  item added
- Git:
  - Branches: speed-search finds branches also in collapsed sections
  - Initialize: option to create initial empty commit for better flexibility
  - Log:
    - Copy Messages and Copy ID work on multiple selected commits now
  - Push To: remembers custom ref radio button state
  - when in rebasing or merging state (after a conflict), the toolbar items
    for Commit and Discard should change (<smartgit.userecho.com/topics/34>)
- GUI:
  - Changes, Compare, Conflict Solver:
    - ability to select syntax highlighting language
    - current-line highlight in gutter only when focused
  - Repository:
    - "Open Repository in New Window" works for multiple repositories and
      groups
    - speed-search finds repositories also in collapsed groups
    - Open and Clone create new repository in same group as currently opened
      repository

Fixed Bugs
----------
- Git:
  - Log: refreshing comments from GitHub blocked other views like Files or
    Changes
- Bootloader did not work with Java 1.9
- GUI:
  - Commit dialog: file name completion was broken
  - dragging files to other applications did not work for the Relative Path
    column
  - Linux: could not expand/collapse tree nodes using cursor keys
  - Setup wizard: fixed too large space on Executables page


SmartGit 8.1 preview 2 (2016-10-05)
===================================
Noteworthy Changes
------------------
- updated SWT to version 4.712

New Features, Improvements
--------------------------
- Journal, Copy actions: work on multiple selected lines
- Hg:
  - Support for version 3.9.*
- GUI:
  - Compare: shows current-line color in gutter

Fixed Bugs
----------
- Git:
  - Branches, Merge: was not correctly disabled for current branch
  - Refresh: possible internal error related to invalid paths on VM share
- File monitor: on window activation a short time is waited before starting the
  refresh because other applications might store the files on window
  deactivation
- GUI:
  - Setup wizard: the user/email page might get disabled
  - spellchecker did not support contractions (doesn't, ain't, hasn't)
  - possible internal error in case of commands producing very much output
  - work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=501509
    (Ctrl+Alt+<key> may be used to enter characters; such accelerators did
     not work if a text control was focused)
  - Linux:
    - work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=502056
      (radio menu items may not change change the selection state)
    - work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=494619
      (defaultSelection event also was triggered by pressing space)
    - reactivated full-screen option (after updating SWT)
  - OS X:
    - work-around for https://bugs.eclipse.org/bugs/show_bug.cgi?id=501907
     (first output node does not show up immediately)


SmartGit 8.1 preview 1 (2016-09-09)
===================================
New Features, Improvements
--------------------------
- Git:
  - Branches:
    - Delete Tag: made harder to delete from remote by mistake
    - optionally hide remote-only branches in Git-Flow sections
  - Commit: allow to commit while in rebasing state without continuing rebase
  - Journal:
    - Edit Command Message: allows to edit HEAD commit message under same
      conditions as Edit Last Commit Message (e.g. merge commit)
    - optionally switch to any auxiliary ref by double-click
  - Push: forced push checks whether head ever was on remote branch (If a
    forced push failed because of incoming changes, just fetching the changes
    and trying to perform the forced push again was possible)
  - register URL handler for git:// and github-mac://
- Compare: improved inner-line change detection with emphasize on content
  (whitespace is less important for detecting similar blocks)
- Compare, Index Editor, Conflict Solver: Next/Prev Change moves caret in all
  panes, not just the focused one
- GUI:
  - Branches, Journal: if focused, accelerators invoke context-specific command
  - File completion input field: if upper-case character has been entered, an
    upper-case match is preselected
  - right-clicking issue links (e.g. in Journal, Log), shows URL-specific
    context menu
  - Output view: the command output should not be removed by too many output
- Refresh:
  - more responsive, happens earlier
  - background refresh does not refresh up to 5 repositories not marked as
    favorite any more

Fixed Bugs
----------
- Git:
  - Files view, "State" column:
    - incorrect sort order for submodule items
    - for unchanged submodules "As Index" is shown instead of "Unchanged"
  - Conflict Solver: did not properly 'switch' left and right for 'apply'-
    refase (invoked from outside SmartGit)
  - Refresh (Linux): rapid .gitignore modifications could cause high CPU usage
    for a longer time
- Compare, Index Editor, Conflict Solver: undoing changes out of view did not
  scroll the undone change into view
